// -*- C++ -*-
// File: ttt.c
//
// Created: Fri Nov 24 22:08:23 2000
//
// $Id$
//
/*>>>>>>>>>>>>>>>*/
#if 0
void store_key (struct super_block *s, struct key * key)
{
    int i;

    for (i = 0; i < sizeof (g_key_array) / sizeof (g_key_array[0]); i ++) {
	if (g_key_array[i].objectid == 0) {
	    g_key_array[i].dirid = key->k_dir_id;
	    g_key_array[i].objectid = key->k_objectid;
	    g_key_array[i].dev = s->s_dev ;
	    return;
	}
    }
    reiserfs_warning ("vs-13042: store_key: table of keys is full\n");
}


static int read_bitmaps (struct super_block * s)
{
  int i, repeat, bmp, dl ;
  struct reiserfs_super_block * rs = SB_DISK_SUPER_BLOCK(s);

  repeat = 0 ;
  /* read true bitmap block */
  SB_AP_BITMAP (s) = reiserfs_kmalloc (sizeof (struct buffer_head *) * le16_to_cpu (rs->s_bmap_nr), GFP_KERNEL, s);

  if (SB_AP_BITMAP (s) == 0)
	  return 1;

  memset (SB_AP_BITMAP (s), 0, sizeof (struct buffer_head *) * le16_to_cpu (rs->s_bmap_nr));

                /* read bitmap blocks */
				/* reiserfs leaves the first 64k unused
				   so that any partition labeling scheme
				   currently used will have enough
				   space. Then we need one block for the
				   super.  -Hans */
  bmp = (REISERFS_DISK_OFFSET_IN_BYTES / s->s_blocksize) + 1;	/* first of bitmap blocks */
  SB_AP_BITMAP (s)[0] = reiserfs_bread (s->s_dev, bmp, s->s_blocksize, &repeat);

  if(!SB_AP_BITMAP(s)[0])
	  return 1;
  for (i = 1, bmp = dl = rs->s_blocksize * 8; i < le16_to_cpu (rs->s_bmap_nr); i ++)
	  {
		  SB_AP_BITMAP (s)[i] = reiserfs_bread (s->s_dev, bmp, s->s_blocksize, &repeat);
		  if (!SB_AP_BITMAP (s)[i])
			  return 1;
		  bmp += dl;
	  }

  return 0;
}














#if 0


#define has_tail(inode) ((inode)->u.reiserfs_i.i_first_direct_byte != NO_BYTES_IN_DIRECT_ITEM)
#define tail_offset(inode) ((inode)->u.reiserfs_i.i_first_direct_byte - 1)

/* "we are reading into the page cache, not into any process's virtual
   memory". Stephen C. Tweedie, therefore no need for local buffer */
static int read_file_tail (struct inode * inode, loff_t offset, char * buf, int size)
{
    struct key key;
    int repeat, pos_in_item;
    struct path path;
    struct item_head * ih;
    char * p;
    int chars, left, read;
    struct buffer_head * bh;
    int block;
    struct buffer_head * pbh[PAGE_SIZE / 512];
    int i, j;

    p = buf;
    left = size;
    read = 0;

    /* read unformatted nodes first */
    i = 0;
    while (offset < tail_offset (inode))
		{
			block = offset >> inode->i_sb->s_blocksize_bits;
			block = inode->i_op->bmap(inode, block);
			pbh[i] = getblk (inode->i_dev, block, inode->i_sb->s_blocksize);
			offset += inode->i_sb->s_blocksize;
			i ++;
		}
  
    if (i)
		ll_rw_block (READ, i, pbh);

    p = buf;
    for (j = 0; j < i; j ++)
		{
			wait_on_buffer (pbh[j]);
			memcpy (p, pbh[j]->b_data, pbh[j]->b_size);
			read += pbh[j]->b_size;
			left -= pbh[j]->b_size;
			p += pbh[j]->b_size;
			brelse (pbh[j]);
		}


    /* read direct item(s) */

    if (offset != tail_offset (inode))
		{
#ifdef CONFIG_REISERFS_CHECK
			reiserfs_warning ("vs-18010: read_file_tail: given offset (%d) is not stored in direct item. \
Inode's first direct byte %d\n", offset, inode->u.reiserfs_i.i_first_direct_byte);
#endif
			return 0;
		}

    init_path (&path);
	
    copy_short_key (&key, INODE_PKEY(inode));
    key.k_offset = offset + 1;
    key.k_uniqueness = TYPE_DIRECT;

    while (left)
		{
			if (search_for_position_by_key (inode->i_sb, &key, &path, &pos_in_item, &repeat) ==
				POSITION_NOT_FOUND)
				{
					break;
				}
			
			bh = PATH_PLAST_BUFFER (&path);
			ih = B_N_PITEM_HEAD (bh, PATH_LAST_POSITION (&path));
			
			chars = ih->ih_item_len - pos_in_item;
			if (chars > left)
				chars = left;
			
			memcpy (p, B_I_PITEM (bh, ih) + pos_in_item, chars);
			key.k_offset += chars;
			read += chars;
			left -= chars;
			p += chars;
			if (PATH_LAST_POSITION (&path) != B_NR_ITEMS (bh) - 1)
				/* that was last direct item of the tail */
				break;
		}

    pathrelse (&path);
    return read;
}


int reiserfs_readpage (struct file * file, struct page * page) 
{
    struct inode * inode;
    int ret ;

				/* If you get this from the page it is one less indirection -Hans */
    inode = file->f_dentry->d_inode;

    increment_i_read_sync_counter(inode) ;
    if (has_tail (inode) && tail_offset (inode) < page->offset + PAGE_SIZE)
		{
			/* there is a tail and it is in this page */
			memset ((char *)page_address (page), 0, PAGE_SIZE);
			read_file_tail (inode, page->offset, (char *)page_address (page), PAGE_SIZE);
			set_bit (PG_uptodate, &page->flags);
			ret = 0 ;
		}
	else
		{
			ret = generic_readpage (file, page);
		}
    decrement_i_read_sync_counter(inode) ;
    return ret ;
}

/* Iget accepts only super block and inode number as it hashes inodes
   using device identifier and inode number. If iget could not find
   required inode in its hash queues, then it calls
   reiserfs_read_inode passing to it only inode
   number. Reiserfs_read_inode must know the key. That is why we keep
   key in global array before iget.
   */

#define KEY_ARRAY_SIZE 100

static struct
{
    unsigned long objectid;
    unsigned long dirid;
    kdev_t dev ;
} g_key_array [KEY_ARRAY_SIZE] = {{0,},};


static unsigned long look_for_key  (struct super_block *s, unsigned long objectid)
{
    int i;

    for (i = 0; i < sizeof (g_key_array) / sizeof (g_key_array[0]); i ++)
		{
			if (g_key_array[i].objectid == objectid && 
				g_key_array[i].dev == s->s_dev)
				return g_key_array[i].dirid;
		}
    return (unsigned long)-1;
}


/* looks for stat data in the tree, and fills up the fields of in-core
   inode stat data fields */
void reiserfs_read_inode (struct inode * inode)
{
    struct path path_to_sd;
    struct stat_data * sd;
    struct item_head *ih ;
    int repeat;

    init_path (&path_to_sd);

    inode->i_op = NULL;
    inode->i_mode = 0;

    /* form key of the stat data */
    inode->u.reiserfs_i.i_key[0] = look_for_key (inode->i_sb, inode->i_ino);
    inode->u.reiserfs_i.i_key[1] = inode->i_ino;
    inode->u.reiserfs_i.i_key[2] = SD_OFFSET;
    inode->u.reiserfs_i.i_key[3] = TYPE_STAT_DATA;
    if (inode->u.reiserfs_i.i_key[0] == (unsigned long)-1)
		{
#ifdef CONFIG_REISERFS_CHECK
			reiserfs_warning ("vs-13040: reiserfs_read_inode: could not find k_dir_id (objectid = %lu)\n",
							  inode->i_ino);
#endif
	/* VERY slow search through all possible packing localities. */
			if (search_by_objectid(inode->i_sb, INODE_PKEY (inode), &path_to_sd, &repeat,
								   DISK_LEAF_NODE_LEVEL, READ_BLOCKS) != ITEM_FOUND)
				{
					pathrelse (&path_to_sd);
					make_bad_inode(inode) ;
					return ;
				}

			/* ok, the search found our item.  Pull the packing locality from 
			** the path it returned
			*/
			ih = PATH_PITEM_HEAD(&path_to_sd) ;
			inode->u.reiserfs_i.i_key[0] = ih->ih_key.k_dir_id ;
		}

    /* look for the object stat data */
    if (search_by_key (inode->i_sb, INODE_PKEY (inode), &path_to_sd, &repeat, DISK_LEAF_NODE_LEVEL,
					   READ_BLOCKS) == ITEM_NOT_FOUND)
		{
			pathrelse (&path_to_sd);
			make_bad_inode(inode) ;
			return;
		}

    sd = B_N_STAT_DATA (PATH_PLAST_BUFFER (&path_to_sd), PATH_LAST_POSITION (&path_to_sd));
    inode->i_mode = le16_to_cpu (sd->sd_mode);
    inode->i_uid = le16_to_cpu (sd->sd_uid);
    inode->i_gid = le16_to_cpu (sd->sd_gid);
    inode->i_nlink = le16_to_cpu (sd->sd_nlink);
    inode->i_size = le32_to_cpu (sd->sd_size);
    inode->i_mtime = le32_to_cpu (sd->sd_mtime);
    inode->i_atime = le32_to_cpu (sd->sd_atime);
    inode->i_ctime = le32_to_cpu (sd->sd_ctime);
    inode->i_blksize = inode->i_sb->s_blocksize;

    // thanks to Dirk Mueller for fixing "du bug"
    if (S_ISCHR(inode->i_mode) || S_ISBLK(inode->i_mode))
		{
			inode->i_rdev = le32_to_cpu (sd->u.sd_rdev);
			inode->i_blocks = 0;
		}
	else
		{
			/* for regular files we calculate any tail as a whole block */
			unsigned long blocks;
			
			inode->i_rdev = 0;
			inode->i_blocks = le32_to_cpu (sd->u.sd_blocks);
			blocks = (inode->i_size + 511) >> 9;
			blocks = _ROUND_UP (blocks, inode->i_blksize >> 9);
			if (inode->i_blocks > blocks)
				{
					// there was a bug in <=3.5.23 when i_blocks could take negative
					// values. Starting from 3.5.17 this value could even be stored in
					// stat data. For such files we set i_blocks based on file
					// size. Just 2 notes: this can be wrong for sparce files. On-disk value will be
					// only updated if file's inode will ever change
					inode->i_blocks = blocks;
				}
		}
    inode->u.reiserfs_i.i_first_direct_byte = le32_to_cpu(sd->sd_first_direct_byte);
    pathrelse (&path_to_sd);
    
    if (S_ISREG (inode->i_mode))
		inode->i_op = &reiserfs_file_inode_operations;
    else
		if (S_ISDIR (inode->i_mode))
			{
				inode->i_op = &reiserfs_dir_inode_operations;
				inode->i_blocks = inode->i_size / 512 + ((inode->i_size % 512) ? 1 : 0);
			}
		else
			if (S_ISLNK (inode->i_mode))
				inode->i_op = &reiserfs_symlink_inode_operations;
			else
				if (S_ISCHR (inode->i_mode))
					inode->i_op = &chrdev_inode_operations;
				else
					if (S_ISBLK (inode->i_mode))
						inode->i_op = &blkdev_inode_operations;
					else
						if (S_ISFIFO (inode->i_mode))
							init_fifo (inode);
    inode->u.reiserfs_i.i_pack_on_close = 0 ;

}

struct inode * reiserfs_iget (struct super_block * s, struct key * key)
{
    struct inode * inode;

    store_key (s, key);
    inode = iget (s, key->k_objectid);
    if (!inode)
		{
			return NULL ;
		}
    if (comp_short_keys (INODE_PKEY (inode), key))
		{
			reiserfs_warning ("vs-13048: reiserfs_iget: key in inode %k and key in entry %k do not match\n",
							  INODE_PKEY (inode), key);
			iput (inode);
			inode = 0;
		}
    forget_key (s, key);
    return inode;
}

#endif








/*<<<<<<<<<<<<<<*/
